#include "dl_hge_dist.h"

HGE *hge=0;

HTEXTURE			tex;

DL_HGE_DIST dist;
hgeFont*			fnt;

bool FrameFunc()
{
	// Process keys
	switch(hge->Input_GetKey())
	{
		case HGEK_ESCAPE:
			return true;
	}
	
	dist.manage();
	//MessageBox(NULL, "woooo", "Error", MB_OK | MB_ICONERROR | MB_APPLMODAL);
	return false;
}


bool RenderFunc()
{
	// Render graphics
	hge->Gfx_BeginScene();
	hge->Gfx_Clear(0);
	//MessageBox(NULL, "render", "Error", MB_OK | MB_ICONERROR | MB_APPLMODAL);
	dist.draw();
	//MessageBox(NULL, "rendr", "Error", MB_OK | MB_ICONERROR | MB_APPLMODAL);
	fnt->printf(5, 5, HGETEXT_LEFT, "dt:%.3f\nFPS:%d", hge->Timer_GetDelta(), hge->Timer_GetFPS());
	hge->Gfx_EndScene();

	return false;
}


int WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR, int)
{
	hge = hgeCreate(HGE_VERSION);
    char filename[] = "welovefood.png";
	hge->System_SetState(HGE_LOGFILE, "hge_tut05.log");
	hge->System_SetState(HGE_FRAMEFUNC, FrameFunc);
	hge->System_SetState(HGE_RENDERFUNC, RenderFunc);
	hge->System_SetState(HGE_TITLE, "HGE Tutorial 05 - Using distortion mesh");
	hge->System_SetState(HGE_WINDOWED, false);
	hge->System_SetState(HGE_SCREENWIDTH, 1024);
	hge->System_SetState(HGE_SCREENHEIGHT, 768);
	hge->System_SetState(HGE_SCREENBPP, 32);
	hge->System_SetState(HGE_USESOUND, false);
	hge->System_SetState(HGE_SHOWSPLASH, false);

	if(hge->System_Initiate()) {
		// Load a font
		dist.init(hge, filename, 512-400,384-300,800,600,5.0);
		fnt=new hgeFont("font1.fnt");

		// Let's rock now!
		hge->System_Start();

		// Delete created objects and free loaded resources
		delete fnt;
		hge->Texture_Free(tex);
	}

	// Clean up and shutdown
	hge->System_Shutdown();
	hge->Release();
	return 0;
}

