#include "dl_hge_dist.h"

DL_HGE_DIST::DL_HGE_DIST()
{
  
}

DL_HGE_DIST::~DL_HGE_DIST()
{
  delete dis;
}

int DL_HGE_DIST::init(HGE *hge, char *texture, int x, int y, int w, int h, float time, int cols, int rows)
{
  m_hge = hge;
  this->x = x;
  this->y = y;
  this->w = w;
  this->h = h;
  cellw = (float)w/(cols-1);
  cellh = (float)h/(rows-1);
  this->time = time;
  this->cols = cols;
  this->rows = rows;
  multiply = 15.0f;
  t = 0.0f;
  color = 0x00000000;
  
	tex = hge->Texture_Load(texture);
	if(!tex)
	{
		MessageBox(NULL, "Can't load texture", "Error", MB_OK | MB_ICONERROR | MB_APPLMODAL);
		hge->System_Shutdown();
		hge->Release();
		return 0;
	}
	dis=new hgeDistortionMesh(cols, rows);
	dis->SetTexture(tex);
	dis->SetTextureRect(0,0,hge->Texture_GetWidth(tex),hge->Texture_GetHeight(tex));
	dis->SetBlendMode(BLEND_COLORADD | BLEND_ALPHABLEND | BLEND_ZWRITE);
	dis->Clear(color);
	
	/*DWORD *locked;
	locked = hge->Texture_Lock(tex, false, 0, 0, hge->Texture_GetWidth(tex), hge->Texture_GetHeight(tex));
	int xx, yy;
	hgeColorRGB color();
	for(xx = 1; xx < hge->Texture_GetWidth(tex)-1; xx++)
	for(yy = 1; yy < hge->Texture_GetHeight(tex)-1;yy++)
	{
     //locked[yy*hge->Texture_GetHeight(tex)+xx] = color.SetHWColor((locked[yy*hge->Texture_GetHeight(tex)+xx-1] + locked[yy*hge->Texture_GetHeight(tex)+xx+1])/2);        
     //color->SetHWColor(locked[yy*hge->Texture_GetHeight(tex)+xx]);
    }
	hge->Texture_Unlock(tex);
	*/
}

int DL_HGE_DIST::manage()
{
	int i, j;
	if(t < time)
	{
	  float dt = m_hge->Timer_GetDelta();
	  t += dt;
	  if(t > time) t = time;
	  color = (DWORD)(255 * t / time) * 0x1000000;
  	if(multiply > 0.0)
      multiply = 5.0 * (time-t)/time;
  	else multiply = 0.0;
  	for(i=0;i<rows;i++) //sinf(t*10+(i+j)/2)*multiply
  		for(j=0;j<cols;j++)
  		{
  			dis->SetDisplacement(j,i,cosf(t*10+(i+j)/2)*multiply,sinf(t*10+(i+j)/2)*multiply,HGEDISP_NODE);
  			dis->SetColor(j,i,color);
  		}
  		//MessageBox(NULL, "2", "Error", MB_OK | MB_ICONERROR | MB_APPLMODAL);
  }
}

int DL_HGE_DIST::draw()
{
  dis->Render(x,y);
}
