#ifndef __LISTBOX_H
#define __LISTBOX_H

#include "dl_hge_textbox.h"
#include "dl_hge_button.h"

typedef struct _item
{
 int ID;
 char text[128];
 bool selected;        
}ITEM;

class LISTBOX          
{
  public:
         LISTBOX(HGE *nhge);
         ~LISTBOX();
         int draw();
         int manage(int *aap, float delta);
         int ID;
         int x, y, w, h;
         int kolajnica_w;
         int index;
         int vlak_h;
         int showing;
         int set_buttons(char *up_normal, char *up_hover, char *down_normal, char *down_hover);
         int set_font(char *font);
         int set_bitmap(char *vlakfilename, char *hoveronefilename, char *kolajnicafilename);
         void(*proc)(int, char*);
         void up_callback();
         void down_callback();
         HGE *hgge;
         BUTTON up;
         BUTTON down;
         hgeQuad vlak;
         hgeQuad hoverone;
         hgeQuad kolajnica;
         hgeFont *fnt;
         int min, max;
         int value;
         int rozdiel;
         int in_action;
         list<ITEM> items;
         list<ITEM>::iterator search_item_by_id(int id); //not implemented
         list<ITEM>::iterator search_item_by_pos(int pos); //not implemented
         int add_item(int id, char *text);
};

#endif
