#ifndef __PAPER_H
#define __PAPER_H

#include "dl_hge_particles.h"
#include "dl_hge_radiogroup.h"
#include "dl_hge_slider.h"
#include "dl_hge_bitmap.h"
#include "dl_hge_listbox.h"
#include "dl_hge_textbox.h"

class PAPER
{
 public:
        PAPER(HGE *h);
        ~PAPER();
        int draw(int *ap);
        int manage(int *ap);
        int set_background(char *bg, DWORD col = 0xffffffff);
        
        int add_button(int x, int y, int w, int h, int id, int type, int way, void(*proc)());
        int add_particle(char *particle_system, char *particle_texture, int tex_x, int tex_y, int tex_w, int tex_h, int x, int y, int id, int mode);
        int add_checkbox(int x, int y, int w, int h, int id, void(*proc)(bool));
        int add_radiogroup(int x, int y, int klesanie, int id, void(*proc)(int));
        int add_slider(int x, int y, int w, int h, int id, void(*proc)(int));
        int add_bitmap(int id);
        int add_listbox(int x, int y, int w, int h, int id, int vlak_w, void(*proc)(int, char*));
        int add_textbox(int x, int y, int w, int h, int id);
        
                
        list<BUTTON>::iterator search_button(int id);
        list<PARTICLE>::iterator search_particle(int id);
        list<CHECKBOX>::iterator search_checkbox(int id);
        list<RADIOGROUP>::iterator search_radiogroup(int id);
        list<SLIDER>::iterator search_slider(int id);
        list<dlBITMAP>::iterator search_bitmap(int id);
        list<LISTBOX>::iterator search_listbox(int id);
        list<TEXTBOX>::iterator search_textbox(int id);
        
        
        list<BUTTON> buttons;
        list<PARTICLE> particles;
        list<CHECKBOX> checkboxes;
        list<RADIOGROUP> radiogroups;
        list<SLIDER> sliders;
        list<dlBITMAP> bitmaps;
        list<LISTBOX> listboxes;
        list<TEXTBOX> textboxes;
        
        int ID;
        hgeQuad bg;
        HGE *m_hge;
};

#endif
