#include "dl_hge_util.h"

bool lb_was_pressed_var = false;
bool lb_is_pressed_var = false;

int manage_mouse_lb(HGE *hge)
{
  lb_was_pressed_var = lb_is_pressed_var;
  lb_is_pressed_var  = hge->Input_GetKeyState(HGEK_LBUTTON);
}

bool lb_was_pressed()
{
  return lb_was_pressed_var;
}
bool lb_is_pressed()
{
  return lb_is_pressed_var;
}
bool set_lb_unpressed()
{
  lb_was_pressed_var = false;
  lb_is_pressed_var = false;
}

hgeQuad* dl_util_makeHgeQuad(HGE *hge, int x, int y, int w, int h, DWORD col, char *filename)
{
  hgeQuad *q = new hgeQuad();
  q->v[0].x = x;   q->v[0].y = y;   q->v[0].col = col;
  q->v[1].x = x+w; q->v[1].y = y;   q->v[1].col = col;
  q->v[2].x = x+w; q->v[2].y = y+h; q->v[2].col = col;
  q->v[3].x = x;   q->v[3].y = y+h; q->v[3].col = col;
  
  if(filename != NULL)
  {
    q->tex = hge->Texture_Load(filename);
    if(q->tex == 0)
      MessageBox(NULL, hge->System_GetErrorMessage(), filename, MB_OK | MB_ICONERROR | MB_APPLMODAL);
    
    q->v[0].tx = 0.0;
    q->v[1].tx = (float)w / (float)hge->Texture_GetWidth(q->tex);
    q->v[2].tx = (float)w / (float)hge->Texture_GetWidth(q->tex);
    q->v[3].tx = 0.0;
    
    q->v[0].ty = 0.0;
    q->v[1].ty = 0.0;
    q->v[2].ty = (float)h / (float)hge->Texture_GetHeight(q->tex);
    q->v[3].ty = (float)h / (float)hge->Texture_GetHeight(q->tex);
  }
  else q->tex = 0;
  q->blend = BLEND_COLORMUL | BLEND_ALPHABLEND | BLEND_NOZWRITE;
  
  return q;
}

int mir(HGE *hge, int x1, int y1, int x2, int y2, int bp)
{
  float mouse_x, mouse_y;
  bool lbp = hge->Input_GetKeyState(HGEK_LBUTTON);
  bool mbp = hge->Input_GetKeyState(HGEK_MBUTTON);
  bool rbp = hge->Input_GetKeyState(HGEK_RBUTTON);
  hge->Input_GetMousePos(&mouse_x,&mouse_y);
  if(bp == 0){
    if(mouse_x >= (float)x1 && mouse_x <= (float)x2 && mouse_y >= (float)y1 && mouse_y <= (float)y2)
      return 1;
    else return 0;
  }
  else {
    if(mouse_x >= (float)x1 && mouse_x <= (float)x2 && mouse_y >= (float)y1 && mouse_y <= (float)y2)
    {
      if(lbp && bp == 1)
        return 1;
      else if(mbp && bp == 2)
        return 1;
      else if(rbp && bp == 3)
        return 1;
      else return 0;
    }
    else return 0;
  }
}
