#ifndef __DL_WS_CLIENT
#define __DL_WS_CLIENT

#include <hge.h>
#include <winsock2.h>
#include <ws2tcpip.h>
#include <stdio.h>
#include <signal.h>


typedef struct __BUFFER
{
  char buffer[128];
}BUFFER;

class DL_WS_CLIENT
{
  public:
    DL_WS_CLIENT();
    ~DL_WS_CLIENT();
    int init_ws();
    int deinit_ws();
    int connect_to_server();
    int disconnect();
    int set_account(const char *nick, const char *passwd);
    int select_server(const char *ip, const char *port);
    int dl_send(const char* buffer);
    char *dl_recv();
    
    
    char nick[32];
    char passwd[32];
    char serverip[16];
    char serverport[8];
    char sendbuffer[128];
    char recvbuffer[128];
    int ID;
    
    WSADATA wsaData;
    SOCKET ServerSocket;
    
    FILE *clientlog;
};

#endif

/*
    
  
    // Send an initial buffer
    iResult = send( ConnectSocket, sendbuf, (int)strlen(sendbuf), 0 );
    if (iResult == SOCKET_ERROR) {
        printf("send failed: %d\n", WSAGetLastError());
        closesocket(ConnectSocket);
        WSACleanup();
        return 1;
    }

    printf("Bytes Sent: %ld\n", iResult);

    // shutdown the connection since no more data will be sent
    iResult = shutdown(ConnectSocket, SD_SEND);
    if (iResult == SOCKET_ERROR) {
        printf("shutdown failed: %d\n", WSAGetLastError());
        closesocket(ConnectSocket);
        WSACleanup();
        return 1;
    }

    // Receive until the peer closes the connection
    do {

        iResult = recv(ConnectSocket, recvbuf, recvbuflen, 0);
        if ( iResult > 0 )
            printf("Bytes received: %d\n", iResult);
        else if ( iResult == 0 )
            printf("Connection closed\n");
        else
            printf("recv failed: %d\n", WSAGetLastError());

    } while( iResult > 0 );

    // cleanup
    closesocket(ConnectSocket);
    WSACleanup();

    return 0;

*/
