#include "magemodry.h"

MAGEMODRY::MAGEMODRY()
{
  direction = 1;
  frame = 0.0f;
  cas = 0.0f;
  ubralsi = 0.0f;
  frozen = 0;
  charmed = 0;
  sleeped = 0;
  lifted = 0;
  liftedstarty = 0.0f;
}

MAGEMODRY::~MAGEMODRY()
{}

int MAGEMODRY::init(int id, int **dta)
{
 ID = id;
 data = dta;
 HTEXTURE tex;
 tex = hgge->Texture_Load("img/particles.png");
 sprsleep = new hgeSprite(tex, 96, 96, 32, 32);
 sprsleep->SetColor(0xffffffff);
 sprsleep->SetBlendMode(BLEND_COLORMUL | BLEND_ALPHAADD | BLEND_NOZWRITE);
 parsleep = new hgeParticleSystem("par/sleeping.psi", sprsleep);    
 parsleep->info.nEmission = 5;
 cfr.init(tex);
 cfr.hgge = hgge;
}

int MAGEMODRY::manage(float camleft, float p_frozen, float px, float py, float *life, bool p_attacks, int p_atk, int smer, float bubbletime, int mw, float mwx, float mwy, int a_atk, int asi1, int asi2, float asx1, float asy1, float asx2, float asy2, MINE *m1, MINE *m2, MINE *m3)//, int m1p, int m1x, int m1y, int m2p, int m2x, int m2y, int m3p, int m3x, int m3y)
{
  
  float dt;
  dt = hgge->Timer_GetDelta();
  parsleep->Update(dt); 
  if(sleeped == 0 && parsleep->GetParticlesAlive() > 0)
  {
    parsleep->Stop();
  }
  else if(sleeped > 0)
  {
    parsleep->Transpose(x-camleft,y);
  }
  
  if(lifted)
  {
    if(sleeped > 0) sleeped = 0;
    else
    {
      vy += 0.1f;  
      y += vy;
      if(y >= liftedstarty)
      {
        vy = 0.0f;
        y = liftedstarty;
        lifted = 0;
      }
    }
  }
  else if(frozen > 0) frozen--;
  else if(charmed > 0) charmed--;
  else if(sleeped > 0) sleeped--;
  else
  {
    if(px < x)
    {
      if(direction == true)
      {
        //x-=32;
        direction = false;
      }
    }
    else
    {
      if(direction == false)
      {
        //x+=32;
        direction = true;
      }   
    }
    
    if(cfr.vystreleny == 1)
    {
      if(frame < MAXFRAME-4.0f)frame += 0.1;
      if(frame > MAXFRAME)frame = 0.0f;
    }
    if(cfr.vystreleny == 0 && p_frozen <= 0.0f && cas <= 0.0f)
    {
      cas = 25.0f;
      cfr.y = y+32;
      cfr.vystreleny = 1;
      if(!direction)
      {
        cfr.x = x+16;
        cfr.vx = -3.5f;
      }
      if(direction)
      {
        cfr.x = x+32;
        cfr.vx = 3.5f;
      }
      frame = 0.0f;
      cfr.par->Fire();
    }
    if(cas > 0.0f) cas -= 0.1f;
    /*if(abs((int)(px - x)) < 32 && abs((int)(py - y)) < 64 && udrel <= 0.0f && bubbletime <= 0.0f)
    {
      *life -= 100;
      udrel = 10.0f;
    }
    else
    {
      if(udrel > 0.0f) udrel -= 0.1f;
    }*/
    if(m1->polozena && abs((int)(x - m1->x)) < 32 && (m1->y - y) < 64 && (m1->y - y) > 0)
    {
      if(sleeped > 0) sleeped = 0;
      else this->life -= 100;
      m1->polozena = 0;
      m1->cas = 0;
      m1->par->Fire();
    }
    if(m2->polozena && abs((int)(x - m2->x)) < 32 && (m2->y - y) < 64 && (m2->y - y) > 0)
    {
      if(sleeped > 0) sleeped = 0;
      else this->life -= 100;
      m2->polozena = 0;
      m2->cas = 0;
      m2->par->Fire();
    }
    if(m3->polozena && abs((int)(x - m3->x)) < 32 && (m3->y - y) < 64 && (m3->y - y) > 0)
    {
      if(sleeped > 0) sleeped = 0;
      else this->life -= 100;
      m3->polozena = 0;
      m3->cas = 0;
      m3->par->Fire();
    }
  }
  
  if(asi1)
  {
    if(abs((int)(x - asx1)) < 32 && abs((int)(y - asy1)) < 64 && ubralsi <= 0.0f)
    {
      if(sleeped > 0) sleeped = 0;
      else this->life -= a_atk;
      ubralsi = 10.0f;
    }
    else if(ubralsi > 0.0f) ubralsi -= 0.1f;
  }
  if(asi2)
  {
    if(abs((int)(x - asx2)) < 32 && abs((int)(y - asy2)) < 64 && ubralsi <= 0.0f)
    {
      if(sleeped > 0) sleeped = 0;
      else this->life -= a_atk;
      ubralsi = 10.0f;
    }
    else if(ubralsi > 0.0f) ubralsi -= 0.1f;
  }
  
  if(smer == 4)
    if((px - x) < 64 && (px - x) > 0 && abs((int)(py - y)) < 64 && p_attacks)
    {
      if(sleeped > 0)
        sleeped = 0;
      else
        this->life -= p_atk;
    }
  if(smer == 6)
    if((x - px) < 64 && (x - px) > 32 && abs((int)(py - y)) < 64 && p_attacks)
    {
      if(sleeped > 0)
        sleeped = 0;
      else 
        this->life -= p_atk;
    }
}
