#include "dl_hge_menu.h"

DL_HGE_MENU::DL_HGE_MENU()
{
  //printf("spravil som menu\n");
  active_paper = 10;
}

DL_HGE_MENU::~DL_HGE_MENU()
{
  //printf("znicil som menu\n");
}

int DL_HGE_MENU::draw()
{
  list<PAPER>::iterator it;
  
  for(it = papers.begin(); it != papers.end() ; it++)
  {
    it->draw(&active_paper);
  }
  
  //Render mouse
  if(spt_mouse != NULL)
  {
    float m_x, m_y;
    m_hge->Input_GetMousePos(&m_x,&m_y);
    if(m_hge->Input_IsMouseOver())
      spt_mouse->Render(m_x, m_y);
  }
  else if(mouse_par != NULL)
  {
    if(m_hge->Input_IsMouseOver())
      mouse_par->Render();
  }
  return 1;
}

int DL_HGE_MENU::manage()
{
  float dt = m_hge->Timer_GetDelta();
  list<PAPER>::iterator it;
  manage_mouse_lb(m_hge);
  for(it = papers.begin(); it != papers.end() ; it++)
  {
    if(it->manage(&active_paper) == 0) return 0;
  }
  
  if(mouse_par != NULL)
  {
    float m_x, m_y;
    m_hge->Input_GetMousePos(&m_x,&m_y);
    mouse_par->MoveTo(m_x,m_y);
    mouse_par->Update(dt);
  }
  return 1;
}

int DL_HGE_MENU::init_mouse(char *filename, int hotspotx, int hotspoty)
{
  HTEXTURE mouse_tex;
  mouse_tex = m_hge->Texture_Load(filename);
  spt_mouse = new hgeSprite(mouse_tex, 0, 0, 32, 32);
  spt_mouse->SetBlendMode(BLEND_COLORMUL | BLEND_ALPHABLEND | BLEND_NOZWRITE);
  spt_mouse->SetHotSpot(hotspotx, hotspoty);
  
  return 1;
}

int DL_HGE_MENU::init_mouse_particle(char *particle_system, char *particle_texture, int tex_x, int tex_y, int tex_w, int tex_h, int hotspotx, int hotspoty)
{
  mouse_tex = m_hge->Texture_Load(particle_texture);
  mouse_spr = new hgeSprite(mouse_tex, tex_x, tex_y, tex_w, tex_h);
  mouse_spr->SetBlendMode(BLEND_COLORMUL | BLEND_ALPHAADD | BLEND_NOZWRITE);
  mouse_spr->SetHotSpot(hotspotx, hotspoty);
  mouse_par = new hgeParticleSystem(particle_system, mouse_spr);
  mouse_par->Fire();
  
  return 1;
}

int DL_HGE_MENU::add_paper(int id)
{
  PAPER p(m_hge);
  
  p.ID = id;
  
  papers.push_back(p);
  //printf("added paper ID %d\n", p.ID);
  
  return 1;
}

list<PAPER>::iterator DL_HGE_MENU::search_paper(int id)
{
  list<PAPER>::iterator it;
  
  for(it = papers.begin(); it != papers.end(); it++)
  {
    if(it->ID == id) break;
  }
  //printf("nasiel som paper %d\n", it->ID);
  return it;
}
