#include "sekac.h"

SEKAC::SEKAC()
{
  direction = 1;
  frame = 0.0f;
  udrel = 0.0f;
  ubralsi = 0.0f;
  frozen = 0;
  charmed = 0;
  sleeped = 0;
  lifted = 0;
  liftedstarty = 0.0f;
}

SEKAC::~SEKAC()
{}

int SEKAC::init(int id, int **dta)
{
  ID = id;
  //for(int m = 0; m < 192; m++)
  //for(int n = 0; n < 24; n++)
  //  data[m][n] = dta[m][n];
  data = dta;
 HTEXTURE tex;
 tex = hgge->Texture_Load("img/particles.png");
 sprsleep = new hgeSprite(tex, 96, 96, 32, 32);
 sprsleep->SetColor(0xffffffff);
 sprsleep->SetBlendMode(BLEND_COLORMUL | BLEND_ALPHAADD | BLEND_NOZWRITE);
 parsleep = new hgeParticleSystem("par/sleeping.psi", sprsleep);    
 parsleep->info.nEmission = 5;
}

int SEKAC::manage(float camleft, float px, float py, float *life, bool p_attacks, int p_atk, int smer, float bubbletime, int mw, float mwx, float mwy, int a_atk, int asi1, int asi2, float asx1, float asy1, float asx2, float asy2, MINE *m1, MINE *m2, MINE *m3)//, int m1p, int m1x, int m1y, int m2p, int m2x, int m2y, int m3p, int m3x, int m3y)
{
  float dt;
  dt = hgge->Timer_GetDelta();
  parsleep->Update(dt); 
  if(sleeped == 0 && parsleep->GetParticlesAlive() > 0)
  {
    parsleep->Stop();
  }
  else if(sleeped > 0)
  {
    parsleep->Transpose(x-camleft,y);
  }
  
  if(lifted)
  {
    if(sleeped > 0) sleeped = 0;
    else
    {
      vy += 0.1f;  
      y += vy;
      if(y >= liftedstarty)
      {
        vy = 0.0f;
        y = liftedstarty;
        lifted = 0;
      }
    }
  }
  else if(frozen > 0) frozen--;
  else if(charmed > 0) charmed--;
  else if(sleeped > 0) sleeped--;
  else
  {
    if(x > endx*32 && direction)
    {
      direction = false;
      vx *= -1;
      x -= 32;
    }
    else if(x < startx*32 && !direction)
    {
      direction = true;
      vx *= -1;
      x += 32;
    }
    x += vx;
    y += vy;
    if(mw == 1 && !direction && x > mwx && x < mwx+32 && y > mwy-64 && y < mwy+64)
    {
     direction =! direction;
     vx *= -1;
     x += 32;
    }
    else if(mw == 1 && direction && x > mwx-32 && x < mwx && y > mwy-64 && y < mwy+64)
    {
     direction =! direction;
     vx *= -1;
     x -= 32;
    }
    if(x < 0)
    {
      x = 0;
      vx *= -1;
    }
    if(x > 6108)
    {
      x = 6108-32;
      vx *= -1;
    }
    frame += 0.1;
    if(frame > MAXFRAME)
     frame = 0.0f;
    
    if(abs((int)(px - x)) < 32 && abs((int)(py - y)) < 64 && udrel <= 0.0f && bubbletime <= 0.0f)
    {
      *life -= this->life;
      udrel = 10.0f;
    }
    else
    {
      if(udrel > 0.0f) udrel -= 0.1f;
    }
    //printf("\n\n ddd: %d %d %d %d %d %d", m1->x, m1->y, m2->x, m2->y, m3->x, m3->y);
    if(m1->polozena && abs((int)(x - m1->x)) < 32 && (m1->y - y) < 64 && (m1->y - y) > 0)
    {
      if(sleeped > 0) sleeped = 0;
      else this->life -= 100;
      m1->polozena = 0;
      m1->cas = 0;
      m1->par->Fire();
    }
    if(m2->polozena && abs((int)(x - m2->x)) < 32 && (m2->y - y) < 64 && (m2->y - y) > 0)
    {
      if(sleeped > 0) sleeped = 0;
      else this->life -= 100;
      m2->polozena = 0;
      m2->cas = 0;
      m2->par->Fire();
    }
    if(m3->polozena && abs((int)(x - m3->x)) < 32 && (m3->y - y) < 64 && (m3->y - y) > 0)
    {
      if(sleeped > 0) sleeped = 0;
      else this->life -= 100;
      m3->polozena = 0;
      m3->cas = 0;
      m3->par->Fire();
    }
  }
  
  if(asi1)
  {
    if(abs((int)(x - asx1)) < 32 && abs((int)(y - asy1)) < 64 && ubralsi <= 0.0f)
    {
      if(sleeped > 0) sleeped = 0;
      else this->life -= a_atk;
      ubralsi = 10.0f;
    }
    else if(ubralsi > 0.0f) ubralsi -= 0.1f;
  }
  if(asi2)
  {
    if(abs((int)(x - asx2)) < 32 && abs((int)(y - asy2)) < 64 && ubralsi <= 0.0f)
    {
      if(sleeped > 0) sleeped = 0;
      else this->life -= a_atk;
      ubralsi = 10.0f;
    }
    else if(ubralsi > 0.0f) ubralsi -= 0.1f;
  }
  
  if(smer == 4)
    if((px - x) < 64 && (px - x) > 0 && abs((int)(py - y)) < 64 && p_attacks)
    {
      if(sleeped > 0)
        sleeped = 0;
      else
        this->life -= p_atk;
    }
  if(smer == 6)
    if((x - px) < 64 && (x - px) > 32 && abs((int)(py - y)) < 64 && p_attacks)
    {
      if(sleeped > 0)
        sleeped = 0;
      else 
        this->life -= p_atk;
    }
}
